//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

OnCustomEvent("vip_death", 0, function(player, params)
{
    if (GetFakeTeam(player) != GetFakeTeam(self))
        return;
    dispenser.Kill();
    trigger.Kill();
    self.Kill();
});

dispenser <- null;
trigger <- null;

function OnPostSpawn()
{
    local dispenserName = "vip_" + UniqueString();

    trigger = SpawnEntityFromTable("dispenser_touch_trigger", {
        origin = self.GetOrigin(),
        targetname = dispenserName,
        spawnflags = 1,
        StartDisabled = 0,
        filtername = "filter_not_vip"
    });
    trigger.KeyValueFromInt("solid", 2);
    trigger.KeyValueFromString("mins", "-140 -140 -96");
    trigger.KeyValueFromString("maxs", "140 140 96");

    dispenser = SpawnEntityFromTable("pd_dispenser",
    {
        origin = self.GetOrigin(),
        teamnum = GetFakeTeam(self),
        touch_trigger = dispenserName
    })
}

function DispenserThink()
{
    if (!self || !self.IsValid())
        return;
    local myPos = self.GetOrigin();
    local frame = GetPropInt(trigger, "m_ubInterpolationFrame");
    trigger.SetAbsOrigin(myPos);
    SetPropInt(trigger, "m_ubInterpolationFrame", frame);
    local frame = GetPropInt(dispenser, "m_ubInterpolationFrame");
    dispenser.SetAbsOrigin(myPos);
    SetPropInt(dispenser, "m_ubInterpolationFrame", frame);
}