//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

entityJunk <- [];

OnCustomEvent("vip_death", 0, function()
{
    foreach (entity in entityJunk)
        if (entity && entity.IsValid())
            entity.Kill();
    self.Kill();
});

function SpawnGlow()
{
    local vip = self.GetMoveParent();

    foreach(player in GetAllPlayers())
        if (GetFakeTeam(player) == GetFakeTeam(self))
        {
            local name = "vip_glow_"+UniqueString();
            local proxy_entity = Entities.CreateByClassname("obj_teleporter");
            proxy_entity.SetAbsOrigin(vip.GetOrigin());
            proxy_entity.DispatchSpawn();
            proxy_entity.SetModel(API_GetString("vip_model"));
            proxy_entity.AddEFlags(Constants.FEntityEFlags.EFL_NO_THINK_FUNCTION);
            proxy_entity.SetSolid(Constants.ESolidType.SOLID_NONE);
            SetPropBool(proxy_entity, "m_bPlacing", true);
            SetPropInt(proxy_entity, "m_fObjectFlags", 2);
            proxy_entity.KeyValueFromString("targetname", name);

            SetPropEntity(proxy_entity, "m_hBuilder", player);

            proxy_entity.SetMoveType(0, 0);
            proxy_entity.SetSolid(0);
            SetPropInt(proxy_entity, "m_fEffects", 129);
            SetPropInt(proxy_entity, "m_nNextThinkTick", 0x7FFFFFFF);
            EntFireByHandle(proxy_entity, "SetParent", "!activator", 0, vip, vip);

            entityJunk.push(proxy_entity);

            local tf_glow = SpawnEntityFromTable("tf_glow", {
                target = name
                StartDisabled = 0
                GlowColor = GetFakeTeam(self) == TF_TEAM_RED ? "190 48 48 255" : "179 225 255 255"
            });
            SetPropBool(tf_glow, "m_bForcePurgeFixedupStrings", true);
            entityJunk.push(tf_glow);
        }
}
RunWithDelay(0.1, SpawnGlow);