::WEAPON_TYPES <- [
    {
        names = ["tommygun"],
        baseclass = "tf_weapon_handgun_scout_primary",
        baseid = 16,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl",
        weaponmodel = "models/weapons/w_models/w_tommygun_test.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("bullets per shot bonus", 0.5, -1);
            weaponEnt.AddAttribute("fire rate bonus", 0.25, -1);
            weaponEnt.AddAttribute("clip size bonus", 10, -1);
            weaponEnt.AddAttribute("damage bonus HIDDEN", 0.54, -1);
            weaponEnt.AddAttribute("hidden primary max ammo bonus", 0.6, -1);
            weaponEnt.SetClip1(40);
        }
    },
    {
        names = ["snipistol"],
        baseclass = "tf_weapon_pistol",
        baseid = 23,
        animmodel = "models/weapons/c_models/c_spy_arms.mdl",
        weaponmodel = "models/workshop/weapons/c_models/c_ttg_sam_gun/c_ttg_sam_gun.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("clip size bonus", 0.05, -1);
            weaponEnt.AddAttribute("damage bonus", 2.7, -1);
            weaponEnt.AddAttribute("dmg falloff decreased", 5, -1);
            weaponEnt.AddAttribute("reload time increased", 2.5, -1);
            weaponEnt.AddAttribute("hidden secondary max ammo penalty", 0.2, -1);
            weaponEnt.SetClip1(1);
        },
        OnSwitch = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(1); //todo infinite ammo glitch
        }
    },
    {
        names = ["cane"],
        baseclass = "tf_weapon_shovel",
        animmodel = API_GetString("vip_arms_model"),
        weaponmodel = API_GetString("cane_model"),
        baseid = 196,
        OnEquip = function(player, weaponTT, weaponEnt) {
            //weaponEnt.AddAttribute("damage bonus HIDDEN", 0.54, -1);
            //weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.625, -1);
        }
    }
];