::GetWeaponTypeByName <- function(name)
{
    foreach (weaponTT in WEAPON_TYPES)
        if (weaponTT.names.find(name) != null)
            return weaponTT;
    return null;
}

::GetWeaponTypeFromEntity <- function(weaponEntity)
{
    if (!weaponEntity)
        return null;
    return safeget(weaponEntity.GetScriptScope(), "weaponTT", null);
}

::FindWeaponEntityByType <- function(player, weaponTT)
{
    for (local i = 0; i < 10; i++)
    {
        local weaponEnt = GetPropEntityArray(player, "m_hMyWeapons", i);
        if (!weaponEnt)
            continue;
        local weaponScript = weaponEnt.GetScriptScope();
        if ("weaponTT" in weaponScript && weaponScript.weaponTT == weaponTT)
            return weaponEnt;
    }
    return null;
}