//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

//!CompilePal::IncludeDirectory("models/vip")
//!CompilePal::IncludeDirectory("materials/models/vip")
//!CompilePal::IncludeDirectory("scripts/vscripts/__lizardlib")
//!CompilePal::IncludeDirectory("scripts/vscripts/vip")

ClearGameEventCallbacks();

::isDebug <- !IsDedicatedServer() && false;

try { IncludeScript("vip_addons/main_pre.nut"); } catch(e) { }

::API_DEF_VALUES <- {
    "vip_model": "models/player/tfc_civilian.mdl"
    "vip_hat_model": "models/vip/player/civilian/julius_hat.mdl"
    "hat_gib": "models/vip/player/gibs/gibs_civilianhat_blue.mdl"
    "vip_arms_model": "models/vip/weapons/c_models/c_civilian_arms.mdl"
    "cane_model": "models/vip/weapons/c_models/c_cane/c_cane.mdl"
    "cane_pickup_model": "models/vip/weapons/c_models/c_cane/c_cane.mdl"
    "boost_token_model": "models/items/crystal_ball_pickup_major.mdl"
    "is_attack_defend": "1"
}

IncludeScript("__lizardlib/_lizardlib.nut");
IncludeScript("_charlib/_custom_character.nut");

PrecacheModel(API_GetString("vip_model"));
PrecacheModel(API_GetString("vip_arms_model"));
PrecacheModel(API_GetString("cane_model"));

IncludeScript("vip/gamemode/_gamemode.nut");

IncludeScript("vip/maintenance.nut");

try { IncludeScript("vip_addons/main.nut"); } catch(e) { }