characterName <- "vip";
characterClass <- TF_CLASS_HEAVY;
characterModel <- API_GetString("vip_model");
customArms <- "models/weapons/c_models/c_spy_arms.mdl";

IncludeScript("vip/vip/vip_buff_lockon.nut");
IncludeScript("vip/vip/vip_buffs.nut");
IncludeScript("vip/vip/vip_headshot.nut");
IncludeScript("vip/vip/vip_nag.nut");
IncludeScript("vip/vip/vip_mediccall.nut");
IncludeScript("vip/vip/vip_fixes.nut");
IncludeScript("vip/vip/vip_experiments.nut");

/*EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
{
    origin = self.GetCenter(),
    vscripts = "vip/entities/vip_dispenser.nut",
    thinkfunction = "DispenserThink",
    TeamNum = GetFakeTeam(self)
}), "SetParent", "!activator", 0, self, self);*/

EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
{
    origin = self.GetCenter(),
    vscripts = "vip/entities/vip_team_outline.nut",
    TeamNum = GetFakeTeam(self)
}), "SetParent", "!activator", 0, self, self);

AddTimer(1, function()
{
    local hp = self.GetHealth();
    local newHP = clampCeiling(self.GetMaxHealth(), hp + 3);
    if (hp > 0 && newHP > hp)
        self.SetHealth(newHP);
});

OnSelfGameEvent("post_inventory_application", 0, function()
{
    self.AddHudHideFlags(HIDEHUD_PIPES_AND_CHARGE);
    SetPropInt(self, "m_Shared.m_bShieldEquipped", 0);
    vipBoostTokens <- vipBoostTokensStart;
    self.KeyValueFromString("targetname", "vip");

    self.AddCustomAttribute("voice pitch scale", 0, -1);
    self.AddCustomAttribute("patient overheal penalty", 0.2, -1);

    self.SetHealth(500);
    self.SetMaxHealth(500);
    self.RemoveCustomAttribute("max health additive penalty");
    self.AddCustomAttribute("max health additive penalty", 200, -1);

    self.SetModelScale(1.6, -1);

    vipBoostTokens = vipBoostTokensMax;

    self.Weapon_Switch(EquipWeapon(GetWeaponTypeByName("tommygun")));
    EquipWeapon(GetWeaponTypeByName("snipistol"));
    EquipWeapon(GetWeaponTypeByName("cane"));

    /*local weapon = GivePlayerWeapon("tf_weapon_shovel", 6);
    weapon.SetModelSimple(API_GetString("vip_arms_model"));
    weapon.SetCustomViewModelModelIndex(GetModelIndex(API_GetString("vip_arms_model")));
    SetPropInt(weapon, "m_iViewModelIndex", GetModelIndex(API_GetString("vip_arms_model")));
    weapon.DisableDraw();*/

    /*local stockViewmodelEnt = GetPropEntity(self, "m_hViewModel");
    stockViewmodelEnt.DisableDraw();
    stockViewmodelEnt.SetModelSimple(API_GetString("vip_arms_model"));

    CreateViewModel(API_GetString("vip_arms_model"));
    CreateViewModel(API_GetString("cane_model"));*/
    //CreateWorldModel(API_GetString("cane_model"));
    //CreateWorldModel(API_GetString("vip_hat_model"));
});

OnSelfGameEvent("player_death", 0, function(player, params)
{
    KillLockVFX();
    DoEntFire(GetFakeTeamName(player) + "_vip_death*", "Trigger", "", -1, player, player);
    FireCustomEvent("vip_death", params);
});